EnableExplicit

Define PBEx_Speech

CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
  PBEx_Speech = OpenLibrary(#PB_Any, "PB.Ex_Speech_x86.dll")
CompilerElseIf #PB_Compiler_Processor = #PB_Processor_x64
  PBEx_Speech = OpenLibrary(#PB_Any, "PB.Ex_Speech_x64.dll")
CompilerEndIf

If PBEx_Speech
  Prototype TextToSpeaker(Text.p-Unicode, Voice.p-Unicode, Speed, Volume, Asynchronous, ErrorOutput)
  Define TextToSpeaker.TextToSpeaker = GetFunction(PBEx_Speech, "TextToSpeaker")
  Prototype TextToAudioFile(Text.p-Unicode, Voice.p-Unicode, Speed, Volume, SaveFilePath.p-Unicode, ErrorOutput)
  Define TextToAudioFile.TextToAudioFile = GetFunction(PBEx_Speech, "TextToAudioFile")
  Prototype SpeechRecognition(WordArray, WordArraySize, ErrorOutput)
  Define SpeechRecognition.SpeechRecognition = GetFunction(PBEx_Speech, "SpeechRecognition")
  Prototype WaitSpeechRecognition(RecognizedWord)
  Define WaitSpeechRecognition.WaitSpeechRecognition = GetFunction(PBEx_Speech, "WaitSpeechRecognition")
  Prototype KillSpeechRecognition()
  Define KillSpeechRecognition.KillSpeechRecognition = GetFunction(PBEx_Speech, "KillSpeechRecognition")
  
  ;Define ErrorOutput$ = ""
  ;If TextToSpeaker("Hallo PureBasic-Freunde", "", 1, 100, 0, @ErrorOutput$) <> 0
  ;  Debug ErrorOutput$
  ;EndIf
  
  ;Define ErrorOutput$ = ""
  ;If TextToAudioFile("Hallo PureBasic-Freunde", "", 1, 100, "D:\AudioText.wav", @ErrorOutput$) <> 0
  ;  Debug ErrorOutput$
  ;EndIf
  
  Define RecognizedWord$ = Space(1024)
  Define ErrorOutput$ = Space(1024)
  Define IsRecognized
  Dim WordArray.s(5)
  WordArray(0) = "Hallo"
  WordArray(1) = "Waschmaschine"
  WordArray(2) = "Installation"
  WordArray(3) = "Basic"
  WordArray(4) = "Willkommen"
  WordArray(5) = "Liebe"
  
  If SpeechRecognition(0, 0, @ErrorOutput$) = 0
    WaitSpeechRecognition(@RecognizedWord$)
    Debug RecognizedWord$
  EndIf
  
  If SpeechRecognition(WordArray(), ArraySize(WordArray())+1, @ErrorOutput$) = 0
    Repeat
      IsRecognized = WaitSpeechRecognition(@RecognizedWord$)
      If IsRecognized = 1
        Debug "Recognized: " + RecognizedWord$
        Break
      ElseIf IsRecognized = 2
        If RecognizedWord$ = ""
          Debug "Nothing was recognized correctly."
        Else
          Debug "Not recognized correctly, maybe this word: " + RecognizedWord$ + "?"
        EndIf
      EndIf
    ForEver
  EndIf
  
  KillSpeechRecognition()
  
  CloseLibrary(PBEx_Speech)
EndIf
; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 45
; FirstLine = 7
; EnableXP
; EnableUser
; Executable = PB.Ex_MSSQL_x86.exe
; EnableCompileCount = 143
; EnableBuildCount = 6